if (location.hostname.includes('teams.microsoft')) document.body.classList.add('microsoft-teams');

if (location.pathname.includes('launcher')) document.body.classList.add('teams-launcher');

var startTime = + new Date();

setInterval(function () {

	// console.log('content script is active');

	var timeOnPage = (+ new Date()) - startTime;

	if (location.protocol != 'chrome:') {

		if (window.localStorage && localStorage.getItem) {
			// Key is set
			var _dk = localStorage.getItem('_dk');
			//if (_dk) console.log('Display key set to:', _dk);

			// Command received
			var _rcmd = localStorage.getItem('_rcmd');
			if (_rcmd) {
				localStorage.removeItem('_rcmd');
				console.log('_rcmd', _rcmd);

				// Handle commands
				if (_rcmd == 'video-on') {
					if (document.querySelector('.icons-video-off') && document.querySelector('#video-button')) document.querySelector('#video-button').click();
					if (document.querySelector('.icons-video-off') && document.querySelector('#video-button')) document.querySelector('#video-button').click();
				} else if (_rcmd == 'video-off') {
					if (document.querySelector('.icons-call-video') && document.querySelector('#video-button')) document.querySelector('#video-button').click();
					if (document.querySelector('.icons-call-video') && document.querySelector('#video-button')) document.querySelector('#video-button').click();
				} else if (_rcmd == 'mic-on') {
					if (document.querySelector('.icons-call-microphone-off, .icons-call-microphone-off-filled') && document.querySelector('#microphone-button')) document.querySelector('#microphone-button').click();
					if (document.querySelector('.icons-call-microphone-off, .icons-call-microphone-off-filled') && document.querySelector('#microphone-button')) document.querySelector('#microphone-button').click();
				} else if (_rcmd == 'mic-off') {
					if (document.querySelector('.icons-call-microphone, .icons-call-microphone-filled') && document.querySelector('#microphone-button')) document.querySelector('#microphone-button').click();
					if (document.querySelector('.icons-call-microphone, .icons-call-microphone-filled') && document.querySelector('#microphone-button')) document.querySelector('#microphone-button').click();
				} else if (_rcmd == 'end-call') {
					if (document.querySelector('#hangup-button')) document.querySelector('#hangup-button').click();
					if (document.querySelector('#hangup-button')) document.querySelector('#hangup-button').click();
				} else if (_rcmd == 'rejoin-call') {
					if (document.querySelector('button.join-button')) document.querySelector('button.join-button').click();
					if (document.querySelector('button.join-button')) document.querySelector('button.join-button').click();
				} else if (_rcmd.includes('set-url:')) {
					var url = _rcmd.split('set-url:')[1];
					if (!location.hostname.includes('meetingroom365.com')) location.href = url;
					if (!location.hostname.includes('meetingroom365.com')) location.href = url;
				} else {
					alert(_rcmd);
				}
			}
		}

	}


	// Microsoft Teams Meeting Automated Attendant
	if (location.hostname.includes('teams.microsoft')) {

        // Teams video is off
        function videoIsOff () {
            return !!document.querySelector('.icons-video-off');
        }

		// Launcher screen
		if (document.querySelector('#openTeamsClientInBrowser') && location.pathname.includes('launcher'))
			document.querySelector('#openTeamsClientInBrowser').click();

		// Join button (Intro screen)
		if (document.querySelector('.join-btn') && !location.pathname.includes('launcher'))
			document.querySelector('.join-btn').click();

		// If asked to enable desktop notifications, dismiss
		if (document.querySelector('button[title="Dismiss"]'))
			document.querySelector('button[title="Dismiss"]').click();

		// If asked to rate call quality, dismiss
		if (document.querySelector('.rejoin-dismiss-container') && document.querySelector('.rejoin-dismiss-container button'))
			document.querySelector('.rejoin-dismiss-container button').click();

		// If left too early, dismiss
		if (document.querySelector('.questionnaire-buttons button.ts-btn-fluent-secondary-alternate'))
			document.querySelector('.questionnaire-buttons button.ts-btn-fluent-secondary-alternate').click();

		// In a call
		if (document.querySelector('.icons-call-end')) {

			// Always make "fullscreen" (hide menus)
			if (!document.querySelector('body.fullscreen')) {
				document.body.classList.add('fullscreen-layout');
				document.body.classList.add('fullscreen');
			}

			// Always Allow External Guests to Join Immediately
			if (document.querySelector('[calling-screen-focus="admit-participant-button"]'))
				document.querySelector('[calling-screen-focus="admit-participant-button"]').click();

			// If asking for notifications click "Don't ask again"
			if (document.querySelector('[aria-label="Don’t ask again"]'))
				document.querySelector('[aria-label="Don’t ask again"]').click();

		}
	}

	// Sign back in to Teams if prompted, and the password is stored in Chrome
	if (location.hostname == 'login.microsoftonline.com') {
		// Select a user
		if (document.querySelector('.table')) document.querySelector('.table').click();

		// Submit password from Chrome
		if (document.querySelector('input[name="passwd"]') && document.querySelector('input[name="passwd"]').value) {
			if (document.querySelector('input[type="submit"]')) document.querySelector('input[type="submit"]').click();
		}

		// Stay signed in
		if (document.querySelector('input[type="checkbox"]') && document.querySelector('#idBtn_Back')) {
			if (document.querySelector('input[type="submit"]')) document.querySelector('input[type="submit"]').click();
		}
	}

	// Google Meet Automated Attendant
	if (location.hostname == "meet.google.com") {

        // isMuted
        function isMuted () {
            return !!document.querySelector('[aria-label="Turn on microphone"]')
        }

        function join () {
            if (document.querySelector('[aria-label="Join meeting. "]'))
                document.querySelector('[aria-label="Join meeting. "]').click();
        }

        if (document.querySelector('[role="status"]')) {
            // Join the meeting even if no one else is here
            if (document.querySelector('[role="status"]').textContent.includes('one else'))
                join();

            // Join the meeting if people are here
            if (document.querySelector('[role="status"]').textContent.includes('in the meeting'))
                join();
        }

        // If Mic is off, unmute me
        if (document.querySelector('[aria-label="Turn on microphone"]')) document.querySelector('[aria-label="Turn on microphone"]').click();

        // If video is off, turn it back on
        if (document.querySelector('[aria-label="Turn on camera"]')) document.querySelector('[aria-label="Turn on camera"]').click();

        // If Mic is on, turn it off
        // if (document.querySelector('[aria-label="Turn off microphone"]')) document.querySelector('[aria-label="Turn off microphone"]').click();

        // Leave call
        // document.querySelector('[aria-label="Leave call"]').click();

	}

	// Google Hangouts
	if (location.hostname == "hangouts.google.com") {

	}

	// Daily.co
	if (location.hostname.includes("daily.co")) {

		// Splash Screen
		if (document.querySelector('meta[property="og:title"]') && document.querySelector('meta[property="og:title"]').content == "Join my Daily video call!") {
			setTimeout(function () { if (document.querySelector('.dQbJLa')) document.querySelector('.dQbJLa').click() }, 1000);
		}

		// Toggle Video: document.querySelectorAll('.fZGHZb')[0].click()

		// Toggle Mic: document.querySelectorAll('.fZGHZb')[1].click()

		// End Call: document.querySelectorAll('.fZGHZb')[7].click()
	}

	// Bluejeans
	if (location.hostname.includes("bluejeans.com")) {

		// Splash Screen
		if (document.querySelector('.joinMeetingButtonContainer')) {
			document.querySelector('.joinMeetingButtonContainer .primaryButton').click()
		}

		// Toggle Video: document.querySelector('.videoControlButton button').click()

		// Toggle Mic: document.querySelector('.audioControlButton button').click()

		// End Call: document.querySelector('.leaveControlButton button').click()
	}


	// Appear.in
	if (location.hostname.includes("appear.in")) {
		// No Splash Screen

		// Toggle Video: document.querySelector('.VideoToolbar-item--cam').click()

		// Toggle Mic: document.querySelector('.VideoToolbar-item--mic').click()

		// End Call: document.querySelector('.VideoToolbar-item--leaveRoom').click()
	}



}, 140);

// Set initial state
setTimeout(function () {

	// Microsoft Teams Meeting Automated Attendant
	if (location.hostname.includes('teams.microsoft')) {

		// Always share video
		if (document.querySelector('.icons-video-off') && document.querySelector('#video-button')) document.querySelector('#video-button').click();

		// Always share mic
		if ((document.querySelector('.icons-call-microphone-off') || document.querySelector('.icons-call-microphone-off-filled')) && document.querySelector('#microphone-button')) document.querySelector('#microphone-button').click();

	}

}, 6500);
